﻿using System;
using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;

namespace PhoneStore.Tests.Helpers
{
    public class BasicSteps : IDisposable
    {
        private readonly IWebDriver _driver;
        private const string MainUrl = "http://localhost:5000";
        private const string LoginUrl = MainUrl + "/Account/Login";
        private const string RegisterUrl = MainUrl + "/Account/Register";

        public BasicSteps()
        {
            _driver = new ChromeDriver();
        }
        public void Dispose()
        {
            _driver.Quit();
            _driver.Close();
        }
        public void GoToUrl(string url)
        {
            _driver.Navigate().GoToUrl(url);
        }

        public void GoToMainPage()
        {
            GoToUrl(MainUrl);
        }
        public void GoToLoginPage()
        {
            GoToUrl(LoginUrl);
        }
        public void GoToRegisterPage()
        {
            GoToUrl(RegisterUrl);
        }
        public bool IsElementFound(string text)
        {
            var element = _driver.FindElement(By.XPath($"//*[contains(text(), '{text}')]"));
            return element != null;
        }
        
        public void FillFormField(string fieldId, string text)
        {
            var field = _driver.FindElement(By.Id(fieldId));
            field.SendKeys(text);
        }
        
        public void ClickButtonById(string id)
        {
            _driver.FindElement(By.Id(id)).Click();
        }

        
    }
}