﻿using FluentAssertions;
using PhoneStore.Tests.Helpers;
using Xunit;

namespace PhoneStore.Tests.Selenium
{
    public class AuthTests
    {
        private readonly BasicSteps _basicSteps;

        public AuthTests()
        {
            _basicSteps = new BasicSteps();
        }
        
        [Fact]
        public void LoginWrongModelData_Returns_ErrorMessage()
        {
            _basicSteps.GoToLoginPage();
            _basicSteps.IsElementFound("Вход в приложение").Should().BeTrue();
            _basicSteps.FillFormField("email", "admin@admin.com");
            _basicSteps.FillFormField("password", "test");
            _basicSteps.ClickButtonById("submit");
            _basicSteps.IsElementFound("Неправильный логин и (или) пароль").Should().BeTrue();
        }

        [Fact]
        public void Login_Returns_Page_With_Smartphone_List()
        {
            _basicSteps.GoToLoginPage();
            _basicSteps.IsElementFound("Вход в приложение").Should().BeTrue();
            _basicSteps.FillFormField("email", "admin@admin.com");
            _basicSteps.FillFormField("password", "Admin1234@");
            _basicSteps.ClickButtonById("submit");
            _basicSteps.IsElementFound("Смартфоны - PhoneStore").Should().BeTrue();
        }

        [Fact]
        public void Registration_Returns_Page_With_Smartphone_List()
        {
            _basicSteps.GoToRegisterPage();
            _basicSteps.IsElementFound("Регистрация нового пользователя").Should().BeTrue();
            _basicSteps.FillFormField("email", "test@test.com");
            _basicSteps.FillFormField("age", "45");
            _basicSteps.FillFormField("name", "Test");
            _basicSteps.FillFormField("password", "Admin1234@");
            _basicSteps.FillFormField("passwordConfirm", "Admin1234@");
            _basicSteps.ClickButtonById("submit");
            _basicSteps.IsElementFound("Смартфоны - PhoneStore").Should().BeTrue();
        }
    }
}